!
! WhoWhat.H - Modified from WhatIs.H by A.C. Murie, by David A. Cornelson
!
! 			French translation
!
! Note: I felt I abused it enough so that I would call it another name and add different
!       instructions. WhatIs.H ambiguously answered who and what questions and I wanted
!       them to be answered appropriately. So, I 'fixed' it.
!
! Cette version est la traduction en franais ! Elle n'est peut-tre pas encore
! totallement au point mais permet de dpanner...
!
! USAGE
!
! Include this file after "parser.h".
!
! Add the attribute 'queryable' to your object to allow for WHO am/is/are or WHAT is/am/are
! queries.
!
! Add the whatisit property with a string or function to describe what the object is.
!
! Add whoisit property to describe who the object is.
!
! Additionally, objects that do not appear in the game may be stored in the object
! 'QueryObjs'. They will be in scope all the time, and may be used for general game
! concepts
!
! As a final option, the actions WhoIs and WhatIs may be used in an objects 'before' code
! to print the whoisit or whatisit text.
!
! COMMENTS...
!
! If you intend to allow the player to change to different player objects using ChangePlayer,
! then make sure you write functions to determine which response is appropriate for whatisit
! and whoisit.
!
! The WhoIs routine check's if the object is animate before answering.
!
! I put smartass comments in for defaults.
!

Attribute queryable;
property  whoisit;
property  whatisit;

[ IsAmAre w; w=NextWord(); if (w=='est' or 'suis' or 'sont') return 0; return -1; ];
[ WhatIsWhatSub; "Qu'est-ce que quoi ?"; ];
[ QueryTopic; while( NextWordStopped() ~= -1 ) ; return 1; ];
[ WhatisQSub; "Bonne question."; ];

[ WhoAmISub;
    if( ZRegion(player.whoisit) == 2 or 3 )
    {
        PrintOrRun(player,whoisit);
        rtrue;
    }
    "Une question importante,  laquelle vous n'avez pas de rponse.";
];

[ WhatAmISub;
    if( ZRegion(player.whatisit) == 2 or 3 )
    {
        PrintOrRun(player,whatisit);
        rtrue;
    }
    "Vous tes sans doute un humain, mais on n'est jamais sr de rien de nos jours.";
];

[ WhatIsSub;
    if( noun hasnt queryable ) "Bonne question.";
    if( ZRegion(noun.whatisit) == 2 or 3 )
    {
        PrintOrRun(noun,whatisit);
        rtrue;
    }
    "Vous n'tes pas sr.";
];

[ WhoIsSub;
	if( noun hasnt animate) "Ce n'est pas un ~qui~, c'est un ~que~!";
    if( noun hasnt queryable ) "Bonne question.";
    if( ZRegion(noun.whoisit) == 2 or 3 )
    {
        PrintOrRun(noun,whoisit);
        rtrue;
    }
    "Vous n'tes pas sr.";
];

[ QueryScope;
    if( scope_stage == 1 ) rfalse;
    if( scope_stage == 2 )
    {
        ScopeWithin( QueryObjs );
        rfalse;
    }
];

! uncomment if you don't wish to use it elsewhere in your code
!Object QueryObjs "Queryable objects";

verb meta 'qui'
           * 			-> WhatIsWhat
           * IsAmAre                      -> WhatIsWhat
           * IsAmAre 'suis-je ?'                  -> WhoAmI
           * IsAmAre 'je?'                 -> WhoAmI
           * IsAmAre 'je' '?'              -> WhoAmI
           * IsAmAre scope=QueryScope     -> WhoIs
           * IsAmAre scope=QueryScope '?' -> WhoIs
           * QueryTopic                   -> WhatisQ;

verb meta 'quoi' 'que' 'qu^est' 'qu^' 'qu' 
           *                       -> WhatIsWhat
           * IsAmAre                      -> WhatIsWhat
           * IsAmAre 'suis-je ?'                  -> WhatAmI
           * IsAmAre 'je?'                 -> WhatAmI
           * IsAmAre 'je' '?'              -> WhatAmI
           * scope=QueryScope     -> WhatIs
           * scope=QueryScope '?'    -> WhatIs
           * IsAmAre scope=QueryScope     -> WhatIs
           * IsAmAre scope=QueryScope '?' -> WhatIs
           * IsAmAre 'ce' 'que' scope=QueryScope     -> WhatIs
           * QueryTopic                   -> WhatisQ;
